(**
   {ɦW :  Anim.pas
   {ت:
           Abstract method
          
          ŧi@ Animal & Dog & Cat class,]t method , 
          Animal.Verse method => Virtual Abstract
          Dog.Verse method => override
          Cat.Verse method => override

          Dog.Eat method => Virtual
          Cat.Eat method => Virtual

   [c:
     Animal class
     private                                                |
         Kind: String;                                      | ------->  Other Unit
     public (method)                                        |
       constructor Create;                                  | <-------  Other Object
       function GetKing: string; //ܥثe Kind            |
       function Verse: string; virtual;abstract;            |
                                                            |
     Dog=class(Animal)                                      |
       constructor Create;                                  |
       function Verse: string; override;                    |
       function Eat: string; virtual;                       |
    end;                                                    |
                                                            |
    Cat = class (Animal)                                    |
    public                                                  |
      constructor Create;                                   |
      function Verse: string; override;                     |
      function Eat: string; virtual;                        |
    end;

                                                            |
    var
      MyAnimal: Animal;    // ]wثe  Animal

-----------------------------------------------------------------------
// Polymorphism
type
  Animal = class
  private
    Kind: string;
  public
    function GetKind: string;
    function Verse: string; virtual;
    function Look:String; Dynamic;
    function Sound: String; abstract;
  end;
  Dog = class (Animal)
  public
    function Verse: string; override;
    function Sound: String; override;

  end;
  Cat = class (Animal)
  public
    function Sound: String; override;
  end;
**)

unit Anim;

interface

type
  Animal = class
  private
    Kind: string;
  public
    constructor Create;
    function GetKind: string;
    function Verse: string; virtual; abstract;
  end;

  Dog = class (Animal)
  public
    constructor Create;
    function Verse: string; override;
    function Eat: string; virtual;
  end;

  Cat = class (Animal)
  public
    constructor Create;
    function Verse: string; override;
    function Eat: string; virtual;
  end;


implementation

constructor Animal.Create;
begin
  Kind := 'An animal';
end;

function Animal.GetKind: string;
begin
  GetKind := Kind;
end;

constructor Dog.Create;
begin
  Kind := 'A dog';
end;

function Dog.Verse: string;
begin
  Verse := 'Arf Arf';
end;

function Dog.Eat: string;
begin
  Eat := 'A bone, please!';
end;

constructor Cat.Create;
begin
  Kind := 'A cat';
end;

function Cat.Verse: string;
begin
  Verse := 'Mieow';
end;

function Cat.Eat: string;
begin
  Eat := 'A mouse, please!';
end;

end.

