unit Anim_f;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Anim;

type
  TFormAnimals = class(TForm)
    VerseLabel: TLabel;
    VerseButton: TButton;
    AnimalRadioButton: TRadioButton;
    DogRadioButton: TRadioButton;
    CatRadioButton: TRadioButton;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure VerseButtonClick(Sender: TObject);
    procedure AnimalRadioButtonClick(Sender: TObject);
    procedure DogRadioButtonClick(Sender: TObject);
    procedure CatRadioButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    MyAnimal: Animal;
  public
    { Public declarations }
  end;

var
  FormAnimals: TFormAnimals;

implementation

{$R *.DFM}

procedure TFormAnimals.FormCreate(Sender: TObject);
begin
  MyAnimal := Dog.Create;
end;

procedure TFormAnimals.FormDestroy(Sender: TObject);
begin
  MyAnimal.Free;
end;

procedure TFormAnimals.VerseButtonClick(Sender: TObject);
begin
  VerseLabel.Caption := MyAnimal.Verse; //pGثe Animal ,h| Error
  {
  if (MyAnimal is Dog) or (MyAnimal is Cat) then
      VerseLabel.Caption := MyAnimal.Verse
  else
     VerseLabel.Caption := 'Error: Animal.Verse is Abstract method';
  }
end;

procedure TFormAnimals.AnimalRadioButtonClick(Sender: TObject);
begin
  MyAnimal.Free;
  MyAnimal := Animal.Create;
end;

procedure TFormAnimals.DogRadioButtonClick(Sender: TObject);
begin
  MyAnimal.Free;
  MyAnimal := Dog.Create;
end;

procedure TFormAnimals.CatRadioButtonClick(Sender: TObject);
begin
  MyAnimal.Free;
  MyAnimal := Cat.Create;
end;

procedure TFormAnimals.Button1Click(Sender: TObject);
begin
  if (MyAnimal is Animal) then
      VerseLabel.Caption := 'Animal has not Eat method';  
  if (MyAnimal is Dog) then
      //VerseLabel.Caption := MyAnimal.Eat;  // Error
      VerseLabel.Caption := Dog(MyAnimal).Eat;
  if (MyAnimal is Cat) then
      VerseLabel.Caption := Cat(MyAnimal).Eat;


end;

end.

