(**
   {ɦW :  Dates.pas
   {ت:
          ŧit@ class NewDate ,swqfunction  GetText
           overload [ (SetValue)
          function GetText: string;  //Ǧ^  ^大 
          procedure SetValue (m, d, y: Integer);overload;
          procedure SetValue (par_date:TDatetime);overload;

--------------------------------------------------------------------------
// inherited
type
  // ancestor class
  Date = class
    Month, Day, Year: Integer;
    constructor Init (m, d, y: Integer);
    procedure SetValue (m, d, y: Integer);overload;
  end;

  //descendant class
  NewDate = class (Date)
  public
    function GetText: string;
  end;

implementation

function NewDate.GetText: string;
begin
  // ϥ ancestor class internal data (Month,Day,Year)
  GetText := Format('%d / %d / %d', [Month, Day, Year]);
end;
                                                            |
                                                            |
   {descendant class}
   NewDate = class (Date)
   public
     function GetText: string;
   end;
------------------------------------------------------------------------------------
// Encapsulated(ʸ)
  TDat=class
   private
     Year,Month,Day:integer;
   protected
     function LeapYear: Boolean;
   public
     procedure SetValue(par_yy,par_mm,par_dd:integer);
     Constructor  init(par_yy,par_mm,par_dd:integer);
     function ShowValue:String;
     function GetLastDay:integer;
  end;


  TDat1 = class(TDat)
     function ShowValue:String;
     function GetLastDay:integer;
  end;






**)
unit Date_f;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Dates, StdCtrls;

type
  TDateForm = class(TForm)
    DateLabel: TLabel;
    IncreaseButton: TButton;
    DecreaseButton: TButton;
    Add10Button: TButton;
    Subtract10Button: TButton;
    Button1: TButton;
    procedure IncreaseButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DecreaseButtonClick(Sender: TObject);
    procedure Add10ButtonClick(Sender: TObject);
    procedure Subtract10ButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    TheDay: NewDate;

  public
    { Public declarations }
  end;

var
  DateForm: TDateForm;

implementation

{$R *.DFM}

procedure TDateForm.FormCreate(Sender: TObject);
begin
  TheDay := NewDate.Init(7, 14, 1996);
  DateLabel.Caption := TheDay.GetText;
end;

procedure TDateForm.IncreaseButtonClick(Sender: TObject);
begin
  TheDay.Increase;
  DateLabel.Caption := TheDay.GetText;
end;

procedure TDateForm.DecreaseButtonClick(Sender: TObject);
begin
  TheDay.Decrease;
  DateLabel.Caption := TheDay.GetText;
end;

procedure TDateForm.Add10ButtonClick(Sender: TObject);
begin
  TheDay.Add(10);
  DateLabel.Caption := TheDay.GetText;
end;

procedure TDateForm.Subtract10ButtonClick(Sender: TObject);
begin
  TheDay.Subtract(10);
  DateLabel.Caption := TheDay.GetText;
end;

procedure TDateForm.FormDestroy(Sender: TObject);
begin
  TheDay.Free;
end;

procedure TDateForm.Button1Click(Sender: TObject);
var
  aDate:TDatetime;
begin
  aDate:=StrtoDate('2002/05/01');
  TheDay.SetValue(aDate);
end;

end.

